program mapgen_v2;
{$APPTYPE CONSOLE}
{$I-}
uses
  SysUtils, Math, IniFiles;

const
  IWidth = 256;
  IHeight = 256;

function HexToInt(HexStr: String): Integer;
begin
  result := StrToIntDef('$' + HexStr, 0);
end;


var
  Ini: TIniFile;
  MapLevel: Integer;
  MapSkip: Integer;
  StartX, StopX, StartY, StopY: Integer;
  Server, ActiveMaps: string;
  NetPbmPath: string;
  MapName: string;


procedure GenDownload;
var
  S: string;
  Name: string;
  F, Cmd: TextFile;
  I, X, Y: Integer;
begin
  Write('Generuji skript a seznam souboru ke stazeni... ');
  ActiveMaps := Ini.ReadString('Main', 'ActiveMaps', 'base') + ',';
  AssignFile(Cmd, 'mapgen1_download.cmd');
  ReWrite(Cmd);
  MkDir('resultmap');
  I := 0;
  repeat
    S := Copy(ActiveMaps, 1, Pos(',', ActiveMaps) - 1);
    Name := Ini.ReadString('Base' + S, 'Name', 'base');
    MkDir(Format('base_%s', [Name]));
    AssignFile(F, Format('base_%s\list.dat', [Name]));
    ReWrite(F);
    for X := 0 to (StopX - StartX) div MapSkip do begin
      for Y := 0 to (StopY - StartY) div MapSkip do begin
        WriteLn(F, LowerCase(Format('%s%s/%d_%4x000_%4x000', [Server, Name, MapLevel, StartX + X * MapSkip, StartY + Y * MapSkip])));
        Inc(I);
      end;
    end;
    CloseFile(F);
    WriteLn(Cmd, Format('cd base_%s', [Name]));
    WriteLn(Cmd, '..\wget.exe --input-file=list.dat');
    WriteLn(Cmd, 'cd ..');
    Delete(ActiveMaps, 1, Pos(',', ActiveMaps));
  until Pos(',', ActiveMaps) = 0;
  CloseFile(Cmd);
  WriteLn(Format('%d souboru', [I]));
end;


procedure GenConvertOverlay;
var
  S: string;
  Name, ImgFormat, BaseName, BaseImgFormat: string;
  Cmd: TextFile;
  X, Y: Integer;
begin
  Write('Generuji skript pro konverzi a prolozeni vrstev... ');
  AssignFile(Cmd, 'mapgen2_overlay.cmd');
  ReWrite(Cmd);

  ActiveMaps := Ini.ReadString('Main', 'ActiveMaps', 'base') + ',';
  S := Copy(ActiveMaps, 1, Pos(',', ActiveMaps) - 1);
  BaseName := Ini.ReadString('Base' + S, 'Name', 'base');
  BaseImgFormat := Ini.ReadString('Base' + S, 'ImgFormat', 'gif');
  Delete(ActiveMaps, 1, Pos(',', ActiveMaps));

  for X := 0 to (StopX - StartX) div MapSkip do begin
    for Y := 0 to (StopY - StartY) div MapSkip do begin
      { konverze }
      WriteLn(Cmd, Format('"%s%stopnm.exe" base_%s\%d_%4x000_%4x000 > img_baseimage.pnm', [
        NetPbmPath, BaseImgFormat,
        BaseName, MapLevel, StartX + X * MapSkip, StartY + Y * MapSkip,
        Name
      ]));
      S := ActiveMaps;
      while Pos(',', S) <> 0 do begin
        Name := Ini.ReadString('Base' + Copy(S, 1, Pos(',', S) - 1), 'Name', 'base');
        ImgFormat := Ini.ReadString('Base' + Copy(S, 1, Pos(',', S) - 1), 'ImgFormat', 'gif');

        WriteLn(Cmd, Format('"%s%stopnm.exe" base_%s\%d_%4x000_%4x000 > img_%s.pnm', [
          NetPbmPath, ImgFormat,
          Name, MapLevel, StartX + X * MapSkip, StartY + Y * MapSkip,
          Name
        ]));
        WriteLn(Cmd, Format('"%s%stopnm.exe" -alpha base_%s\%d_%4x000_%4x000 > img_%s_alpha.pnm', [
          NetPbmPath, ImgFormat,
          Name, MapLevel, StartX + X * MapSkip, StartY + Y * MapSkip,
          Name
        ]));

        Delete(S, 1, Pos(',', S));
      end;

      { prokladani }
      S := ActiveMaps;
      while Pos(',', S) <> 0 do begin
        Name := Ini.ReadString('Base' + Copy(S, 1, Pos(',', S) - 1), 'Name', 'base');

        WriteLn(Cmd, Format('"%spnmcomp.exe" -alpha=img_%s_alpha.pnm img_%s.pnm img_baseimage.pnm img_result.pnm', [
          NetPbmPath, Name, Name
        ]));
        WriteLn(Cmd, Format('del img_%s_alpha.pnm', [Name]));
        WriteLn(Cmd, Format('del img_%s.pnm', [Name]));
        WriteLn(Cmd, 'del img_baseimage.pnm');
        WriteLn(Cmd, 'ren img_result.pnm img_baseimage.pnm');

        Delete(S, 1, Pos(',', S));
      end;

      WriteLn(Cmd, Format('move img_baseimage.pnm resultmap\%d_%4x000_%4x000.pnm', [
          MapLevel, StartX + X * MapSkip, StartY + Y * MapSkip
      ]));
    end;
  end;
  CloseFile(Cmd);
  WriteLn('OK');
end;


procedure GenConcat;
var
  Cmd: TextFile;
  X, Y: Integer;
  S: string;
  BaseName: string;
begin
  Write('Generuji skript pro spojeni ctvercu mapy... ');
  AssignFile(Cmd, 'mapgen3_concat.cmd');
  ReWrite(Cmd);

  ActiveMaps := Ini.ReadString('Main', 'ActiveMaps', 'base') + ',';
  S := Copy(ActiveMaps, 1, Pos(',', ActiveMaps) - 1);
  BaseName := Ini.ReadString('Base' + S, 'Name', 'base');

  for Y := 0 to (StopY - StartY) div MapSkip do begin
    Write(Cmd, Format('"%spnmcat.exe" -lr ', [NetPbmPath]));
    for X := 0 to (StopX - StartX) div MapSkip do begin
      Write(Cmd, Format('resultmap/%d_%4x000_%4x000.pnm ', [MapLevel, StartX + X * MapSkip, StartY + Y * MapSkip]));
    end;
    WriteLn(Cmd, Format('> line_%4x000.pnm', [StartY + Y * MapSkip]));
  end;

  Write(Cmd, Format('"%spnmcat.exe" -tb ', [NetPbmPath]));
  for Y := (StopY - StartY) div MapSkip downto 0 do begin
    Write(Cmd, Format('line_%4x000.pnm ', [StartY + Y * MapSkip]));
  end;
  WriteLn(Cmd, Format('> %s.pnm', [MapName]));

  WriteLn(Cmd, 'del /Q line_*.pnm');

  CloseFile(Cmd);
  WriteLn('OK');
end;


procedure GenConvert2;
var
  Cmd: TextFile;
begin
  Write('Generuji skript pro konverzi mapy... ');
  AssignFile(Cmd, 'mapgen4_convert.cmd');
  ReWrite(Cmd);
  WriteLn(Cmd, Format('"%s" %s.pnm %s /convert=%s.%s', [
    Ini.ReadString('Config', 'IrfanViewPath', 'i_view32.exe'),
    MapName,
    Ini.ReadString('Main', 'IrfanViewParams', ''),
    MapName,
    Ini.ReadString('Main', 'ResultFormat', 'png')
  ]));
  CloseFile(Cmd);
  WriteLn('OK');
end;


procedure GenMapFile;
var
  F: TextFile;
  UTM_X1, UTM_X2, UTM_Y1, UTM_Y2: Integer;
  J: Integer;
begin
  Write('Generuji MAP soubor... ');
  AssignFile(F, MapName + '.map');
  ReWrite(F);
  WriteLn(F, 'OziExplorer Map Data File Version 2.2');
  WriteLn(F, MapName);
  WriteLn(F, MapName + '.' + Ini.ReadString('Main', 'ResultFormat', 'png'));
  WriteLn(F, '1 ,Map Code,');
  WriteLn(F, 'WGS 84,WGS 84,   0.0000,   0.0000,WGS 84');
  WriteLn(F, 'Reserved 1');
  WriteLn(F, 'Reserved 2');
  WriteLn(F, 'Magnetic Variation,,,E');
  WriteLn(F, 'Map Projection,(UTM) Universal Transverse Mercator,PolyCal,No,AutoCalOnly,No,BSBUseWPX,No');

  UTM_X1 := (StartX * 4096) div 32 - 3700000;
  UTM_X2 := ((StopX+MapSkip) * 4096) div 32 - 3700000;
  UTM_Y1 := (StartY * 4096) div 32 + 1300000;
  UTM_Y2 := ((StopY+MapSkip) * 4096) div 32 +1300000;

  WriteLn(F, Format('Point%.02d,xy,%5d,%5d,in, deg,    ,        ,N,    ,        ,W, grid, 33,%11d,%11d,N',
                    [1, 0, 0,
                     UTM_X1, UTM_Y2]));
  WriteLn(F, Format('Point%.02d,xy,%5d,%5d,in, deg,    ,        ,N,    ,        ,W, grid, 33,%11d,%11d,N',
                    [2, ((StopX - StartX) div MapSkip + 1) * IWidth - 1, ((StopY - StartY) div MapSkip + 1) * IHeight - 1,
                     UTM_X2, UTM_Y1]));

  for J := 3 to 30 do
    WriteLn(F, Format('Point%.02d,xy,     ,     ,in, deg,    ,        ,N,    ,        ,W, grid,   ,           ,           ,N', [J]));

  WriteLn(F, 'Projection Setup,,,,,,,,,,');
  WriteLn(F, 'Map Feature = MF ; Map Comment = MC     These follow if they exist');
  WriteLn(F, 'Track File = TF      These follow if they exist');
  WriteLn(F, 'Moving Map Parameters = MM?    These follow if they exist');
  CloseFile(F);

  Write('OK');
end;


{ hlavni program }
begin
  WriteLn('');
  WriteLn('MapGen v2.1 # (c) 2006, 2007, 2008 Ales Povalac # <http://www.alpov.net/>');
  WriteLn('=========================================================================');
  Ini := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'mapgen.ini');

  MapLevel := Ini.ReadInteger('Main', 'MapLevel', 16);
  MapSkip := (1 shl (16 - MapLevel));
  Server := Ini.ReadString('Config', 'Server', 'http://mapserver.mapy.cz/');
  NetPbmPath := Ini.ReadString('Config', 'NetPbmPath', '');

  StartX := HexToInt(Ini.ReadString('Main', 'StartX', '0'));
  StopX := HexToInt(Ini.ReadString('Main', 'StopX', '0'));
  StartY := HexToInt(Ini.ReadString('Main', 'StartY', '0'));
  StopY := HexToInt(Ini.ReadString('Main', 'StopY', '0'));

  MapName := Ini.ReadString('Main', 'MapName', 'Test');

  if (StartX mod MapSkip <> 0) or (StopX mod MapSkip <> 0) or
     (StartY mod MapSkip <> 0) or (StopY mod MapSkip <> 0) then
  begin
    WriteLn(Format('Chyba: zadane souradnice musi byt nasobkem cisla 0x%.4x (hexa).', [MapSkip]));
    Exit;
  end;

  if (StopX < StartX) or (StopY < StartY) then begin
    WriteLn('Chyba: neplatne souradnice, Stop < Start.');
    Exit;
  end;

  if ((StopX - StartX) div MapSkip > 100) or ((StopY - StartY) div MapSkip > 100) then begin
    WriteLn('Chyba: prilis velka vysledna oblast, >100 ctvercu horizontalne a/nebo vertikalne.');
    Exit;
  end;

  GenDownload;
  GenConvertOverlay;
  GenConcat;
  GenConvert2;
  GenMapFile;

  WriteLn('');
  Ini.Free;
end.
